/*
 *                            COPYRIGHT
 *
 *  sch-rnd - modular/flexible schematics editor - Redac netlist export
 *  Copyright (C) 2025 Tibor 'Igor2' Palinkas
 *  Copyright (C) 2025 Aron Barath
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 31 Milk Street, # 960789 Boston, MA 02196 USA.
 *
 *  Contact:
 *    Project page: http://repo.hu/projects/sch-rnd
 *    contact lead developer: http://www.repo.hu/projects/sch-rnd/contact.html
 *    mailing list: http://www.repo.hu/projects/sch-rnd/contact.html
 */


#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <librnd/core/compat_misc.h>
#include <librnd/core/safe_fs.h>
#include <librnd/core/plugins.h>
#include <librnd/core/error.h>
#include <libcschem/config.h>
#include <libcschem/plug_io.h>

#include <plugins/lib_netlist_exp/lib_netlist_exp.h>

static csch_plug_io_t eredac_net;

static int redac_export_prio(const char *fn, const char *fmt, csch_plug_io_type_t type)
{
	if (type != CSCH_IOTYP_NETLIST)
		return 0;
	if (rnd_strcasecmp(fmt, "redac") == 0)
		return 100;
	return 0;
}

static void redac_print__value(FILE* const f, const char* str, const char* const title)
{
	if(strchr(str, ' '))
	{
		rnd_message(RND_MSG_ERROR, "redac: Broken output! %s contains illegal characters: %s\n", title, str);
	}

	fputs(str, f);
}

static void redac_print_refdes(FILE* const f, const char* str)
{
	redac_print__value(f, str, "Refdes");
}

static void redac_print_netname(FILE* const f, const char* str)
{
	redac_print__value(f, str, "Netname");
}

static void redac_print_pinnum(FILE* const f, const char* str)
{
	redac_print__value(f, str, "Pin number");
}

/* Export abstract nets; exports net's name and a list of refdes-pinnum */
/* pairs connected */
static void redac_export_nets(FILE *f, csch_abstract_t *abs)
{
	htsp_entry_t *e;
	long n;

	for(e = htsp_first(&abs->nets); e != NULL; e = htsp_next(&abs->nets, e)) {
		csch_anet_t *net = e->value;
		const char *netname = sch_nle_get_netname(net);
		int net_exported = 0; /* net had at least one connection so it was written */

		if (net->hdr.omit) continue;

		for(n = 0; n < net->conns.used; n++) {
			csch_aport_t *port = net->conns.array[n];
			const char *refdes = NULL, *pinnums;

			if (port->hdr.type != CSCH_ATYPE_PORT) {
				rnd_message(RND_MSG_ERROR, "redac: invalid connection (object type)\n");
				continue;
			}

			pinnums = sch_nle_get_pinnum(port);
			if (pinnums == NULL) {
				rnd_message(RND_MSG_ERROR, "redac: can't determine port's pin number\n");
				continue;
			}

			if (port->parent != NULL) {
				refdes = sch_nle_get_refdes(port->parent);
				if (port->parent->hdr.omit)
					continue; /* omit component */
			}
			if (refdes == NULL) {
				/* This is not an error: no refdes means: do not export (e.g. gnd) */
/*				rnd_message(RND_MSG_ERROR, "redac: can't determine port's parent component refdes\n");*/
				continue;
			}

			/* split up pinnum at space and create one or more conn lines connecting
			   each pin to the given net */
			SCH_NLE_FOREACH_PINNUM(pinnums, my_num,
				{
					if(net_exported)
					{
						fputc(' ', f);
					}
					else
					{
						fputs(".REM ", f);
						redac_print_netname(f, netname);
						fputc('\n', f);
						net_exported = 1;
					}

					redac_print_refdes(f, refdes);
					fputc(' ', f);
					redac_print_pinnum(f, my_num);
				}
			);
		}

		/* If the net got exported, close the line */
		if(net_exported)
		{
			fputc('\n', f);
		}
	}
}


/* Export netlist from the abstract model */
static int redac_export_project_abst(const char *fn, const char *fmt, csch_abstract_t *abs, rnd_hid_attr_val_t *options)
{
	TODO("get hidlib as an arg")
	rnd_design_t *hidlib = NULL;
	FILE *f = rnd_fopen(hidlib, fn, "w");
	if (f == NULL)
		return -1;

	fprintf(f, ".PCB\n");
	fprintf(f, ".REM Created by sch-rnd\n");
	fprintf(f, ".CON\n");
	fprintf(f, ".COD 2\n");
	fprintf(f, "\n");

	redac_export_nets(f, abs);

	fprintf(f, ".EOD\n");
	fclose(f);
	return 0;
}

#include "hid_impl.c"

int pplg_check_ver_export_redac(int ver_needed) { return 0; }

void pplg_uninit_export_redac(void)
{
	csch_plug_io_unregister(&eredac_net);
	rnd_export_remove_opts_by_cookie(redac_cookie);
	rnd_hid_remove_hid(&redac_hid);
}

int pplg_init_export_redac(void)
{
	RND_API_CHK_VER;

	eredac_net.name = "export to Redac";
	eredac_net.export_prio = redac_export_prio;
	eredac_net.export_project_abst = redac_export_project_abst;
	eredac_net.ext_export_project = ".net";
	csch_plug_io_register(&eredac_net);


	rnd_hid_nogui_init(&redac_hid);

	redac_hid.struct_size = sizeof(rnd_hid_t);
	redac_hid.name = "redac";
	redac_hid.description = "Exports project's Redac netlist";
	redac_hid.exporter = 1;

	redac_hid.get_export_options = redac_get_export_options;
	redac_hid.do_export = redac_do_export;
	redac_hid.parse_arguments = redac_parse_arguments;
	redac_hid.argument_array = redac_values;

	redac_hid.usage = redac_usage;

	rnd_hid_register_hid(&redac_hid);
	rnd_hid_load_defaults(&redac_hid, redac_options, NUM_OPTIONS);


	return 0;
}

